/*
 * Application.c
 *
 *  Created on: Jul 9, 2018
 *      Author: a0225755
 */

//*****************************************************************************
// Applications.c
//
//! Application functions for TIDM-1021
//
//! Released on July 20, 2018
//
//*****************************************************************************
#include "msp430.h"
#include <captivate.h>           // CapTIvate Touch Software Library
#include "CAPT_UserConfig.h"     // CapTIvate Auto-Generated User Configuration
#include "Application.h"


static uint8_t Touched_Button = 0;


void Board_Init()
{
    TA0CTL = TASSEL__SMCLK | MC__UP; // Set up the timer with SMCLK, UP mode
    TA0CCR0 = 1000;
    LED_ALL_OFF;
}


void Keypad_Callback(tSensor* pSensor)
{
    uint8_t dominantButton;

    //Halt the Long-term-average (LTA) if there is a "negative touch" event when liquid
    //is presented. This will prevent false touch detection after the "negative touch" event.
    if(pSensor->bSensorNegativeTouch == true)
    {
        pSensor->bSensorHalt = true;
    }
    else
    {
        pSensor->bSensorHalt = false;

    }

    //Dominant button lock algorithm
    //This algorithm will determine the dominant button based on the largest delta
    //after there is a touch detected. And the system will lock this dominant button to be the
    //touched button until there is no touch detected.
    if (pSensor->bSensorPrevTouch == false)
    {

        if (pSensor->bSensorTouch == true)
        {
            dominantButton = ((tButtonSensorParams*)(pSensor->pSensorParams))->ui16DominantElement;
            Touched_Button = dominantButton + 1;
            TA0CCTL0 |= CCIE;

        }
        else
        {

            Touched_Button = 0;
            TA0CCTL0 &= ~CCIE;

        }

        Update_LED();
    }

}

void Update_LED()
{

        if(Touched_Button == 1)
        {
            LED_ALL_OFF;
            LED1ON;
        }
        if(Touched_Button == 2)
        {
            LED_ALL_OFF;
            LED2ON;
        }
        if(Touched_Button == 3)
        {
            LED_ALL_OFF;
            LED3ON;
        }
        if(Touched_Button == 4)
        {
            LED_ALL_OFF;
            LED4ON;
        }
        if(Touched_Button == 5)
        {
            LED_ALL_OFF;
            LED5ON;
        }
        if(Touched_Button == 6)
        {
            LED_ALL_OFF;
            LED6ON;
        }
        if(Touched_Button == 7)
        {
            LED_ALL_OFF;
            LED7ON;
        }
        if(Touched_Button == 8)
        {
            LED_ALL_OFF;
            LED8ON;
        }
        if(Touched_Button == 9)
        {
            LED_ALL_OFF;
            LED9ON;
        }
        if(Touched_Button == 10)
        {
            LED_ALL_OFF;
            LED10ON;
        }
        if(Touched_Button == 11)
        {
            LED_ALL_OFF;
            LED11ON;
        }
        if(Touched_Button == 12)
        {
            LED_ALL_OFF;
            LED12ON;
        }
        if(Touched_Button == 0)
        {
            LED_ALL_OFF;
        }

}

#if defined(__TI_COMPILER_VERSION__) || defined(__IAR_SYSTEMS_ICC__)
#pragma vector = TIMER0_A0_VECTOR
__interrupt void Timer_A (void)
#elif defined(__GNUC__)
void __attribute__ ((interrupt(TIMER0_A0_VECTOR))) Timer_A (void)
#else
#error Compiler not supported!
#endif
{
    P1OUT ^= BIT2;
}
